import java.io.*;
import java.net.*;
import javax.swing.*;

public class Client
{
	private Socket				socket;
	private ObjectInputStream	input;
	private ObjectOutputStream	output;
	private String				user,pwd;
	private String				ip;
	private String				port;
	Client(String host)
	{
		socket = null;
		input = null;
		output = null;
		ip = host;
	}
	
	public void setPort(String port) {
		this.port = port;
	}
	public void setHost(String host)
	{
		ip = host;
	}
	
	public void disconnect()
	{
		if(socket != null)
			{
				
				this.Close();
			}
	}
	
	public boolean Connect(String user,String pwd)
	{
		try
		{
			socket = new Socket(InetAddress.getByName(ip),Integer.parseInt(port));
			
			input = new ObjectInputStream(socket.getInputStream());
			output = new ObjectOutputStream(socket.getOutputStream());
			output.flush();
		}
		catch(Exception e)
		{
			return false;
		}
		// do the connection
		String	reply;
		reply = getData();
		
		JOptionPane.showMessageDialog(null,reply);
		sendData(new ChannelInfo("/user",user));
		reply = getData(); 
		sendData(new ChannelInfo("/pass",pwd));
		reply = getData();
		
		
		//JOptionPane.showConfirmDialog(null,user + ":" + pwd);
		//sendData(new ChannelInfo(user,pwd));
		
		
			System.out.println(reply);
			if(reply.charAt(0) != '+')
				return false;
		
		
		this.user	= user;
		this.pwd	= pwd;
		
		return true;
	}
	
	public String getUser()	{ return this.user; }
	
	public String getIP() { return this.ip; }
	
	
	public boolean sendData(ChannelInfo cmd)
	{
		try
		{
			output.writeObject(cmd.channelName + " " + cmd.identifier);
			output.flush();
		}
		catch(Exception e)
		{
			return false;
		}
		
		return true;
	}
	
	String getData()
	{
		String p = "";
		try{
			 p  = (String)input.readObject();
			 
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return p;
	}
	
	public void Close()
	{
		try
		{
			output.close();
			output = null;
			input.close();
			input = null;
			socket.close();
			socket = null;
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}
}