import java.awt.*;
import javax.swing.*;

public class JTitle extends JPanel
{
	private String	sTitle;
	
	JTitle(String title)
	{
		super();
		sTitle = title;
		this.setLayout(new BorderLayout());
		
		int sum = 0;
		for(int i = 0;i<title.length();i++)
		{
			sum+= title.charAt(i);
			
		}
		int x =  sum%13 + 1;
			
		System.out.println(x);
		
		add(new JLabel(new ImageIcon(Integer.toString(x)+".png")),BorderLayout.EAST);
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponents(g);
		
		Graphics2D	g2d = (Graphics2D) g;
		
		g2d.setPaint(new GradientPaint(20,200,new Color(132,193,255),getWidth(),200,Color.WHITE,false));
		g2d.fillRect(0,0,getWidth(),getHeight());
		
		Font font = new Font("Verdana",Font.PLAIN,18);
		g.setFont(font);
		g.setColor(Color.BLACK);
		
		int	h = this.getHeight();
		
		g.drawString(sTitle,20,(int)(h / 2));
	}
	
	public Dimension getPreferredSize()
	{
		return new Dimension(300,70);
	}
}