import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class LogInWindow extends JFrame
{
	JTextField		user,host,port;
	JPasswordField	pass;
	JButton			submit,cancel;
	Client			server;
	VideoClient		parent;
	JLabel			statusLabel = new JLabel();
	static String _uname = "";
	static String  _ip= "192.168.";
	static String _port = "12345";
	
	
	
	LogInWindow(VideoClient p)
	{
		super("LAN TV Login");
		this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
		parent = p;
		
		server = new Client("");
		
		Container	c;
		
		c = this.getContentPane();
		//c.setLayout(new GridLayout(2,1));
		c.setLayout(new BorderLayout());
		c.add(new JLabel(new ImageIcon("connection.png")),BorderLayout.NORTH);
		JPanel	panel;
		
		panel = new JPanel();
		
		panel.setLayout(new GridLayout(5,2));
		
		user = new JTextField(_uname);
		pass = new JPasswordField();
		host = new JTextField(_ip);
		port = new JTextField(_port);
		statusLabel.setText("Press Sign In to Connect to Video Server");
		panel.add(new JLabel("User name"));
		panel.add(user);
		panel.add(new JLabel("Password"));
		panel.add(pass);
		panel.add(new JLabel("Host"));
		panel.add(host);
		panel.add(new JLabel("Port"));
		panel.add(port);
		panel.add(statusLabel);
		c.add(panel,BorderLayout.CENTER);
		
		 JPanel button = new JPanel();
		
		submit = new JButton("Sign in");
		submit.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						
						
						_uname = user.getText();
						_ip = host.getText();
						_port = port.getText();
						server.setHost(_ip);
						server.setPort(_port);
						
						LogInWindow.this.statusLabel.setText("Attempting Connection...");
						if(server.Connect(user.getText(),new String(pass.getPassword())))
						{
							JOptionPane.showMessageDialog(LogInWindow.this,"Connected");
							LogInWindow.this.statusLabel.setText("Authorized");
							setVisible(false);
							parent.processConnection(server);
						}
						else
						{
							LogInWindow.this.statusLabel.setText("Connectin Failed");
							JOptionPane.showMessageDialog(LogInWindow.this,"Error signing in.");
						}
					}
				}
				);
		cancel = new JButton("Cancel");
		cancel.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{		
						System.exit(0);
					}
				}
				);
		
		button.add(submit);
		button.add(cancel);
		
		c.add(button,BorderLayout.SOUTH);
		
		
		setSize(320,300);
		Dimension d = this.getToolkit().getScreenSize();
		setLocation((int)(d.getWidth()-this.getWidth())/2,(int)(d.getHeight()-this.getHeight())/2);
		setResizable(false);
		setVisible(true);
	}
}

